
--shadertoy code implement
--modify shaderFileName to the code file you copied.
--if the shader has any channel file, for example channel0 then shaderChannel[1]=love.graphics.newImage(path to the file)
local resolution={8,6,1} --low resolution for better performance
local files = love.filesystem.getDirectoryItems("shaders")
local currentShader = 0
local shaderFileName="shaders/"..files[currentShader+1]
local shaderChannel={
  --[0]=love.graphics.newImage("channel/tex10.png"),
  --[1]=love.graphics.newImage("channel/tex14.png"),
  --[3]=love.graphics.newImage("channel/tex15.png"),
}

local function loadShader(path)
    local iSystem={}
    local header="\n"
    local ender=[[
vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords){ 
vec2 fragCoord = texture_coords * iResolution.xy; 
mainImage( color, fragCoord ); 
return color; 
}]]
    local file = love.filesystem.newFile(path)
    file:open("r")
    local shaderData = file:read()
    shaderData = string.gsub(shaderData,"texture2D","Texel")
	shaderData = string.gsub(shaderData,"iTime","iGlobalTime")
	shaderData = string.gsub(shaderData,"precision highp float;","")
    if string.find(shaderData,"iGlobalTime") then
      iSystem.iGlobalTime=0
	  if not string.find(shaderData,"number iGlobalTime") then
		header="\nextern number iGlobalTime;"..header
	  end
    end
    if string.find(shaderData,"iChannel") then
      iSystem.iChannel={}
	  if not string.find(shaderData,"Image iChannel") then
		for k,v in pairs(shaderChannel) do
			header="\nextern Image iChannel"..k..";"..header
		end
	  end
    end
    if string.find(shaderData,"iMouse") then
      iSystem.iMouse = {0,0,-1,-1}
	  if not string.find(shaderData,"vec4 iMouse") then
		header="\nextern vec4 iMouse;"..header
	  end
    end
    if string.find(shaderData,"iResolution") then
      iSystem.iResolution = {resolution[1],resolution[2],1}
	  if not string.find(shaderData,"vec3 iResolution") then
		header="\nextern vec3 iResolution;"..header
	  end
    end
	shaderData=header..shaderData
	if not string.find(shaderData,"vec4 effect") then
		shaderData=shaderData.."\n"..ender
	end
	
	return shaderData,iSystem
end
local shaderData
local iSystem
local shader
local canvas

function nextShader(i)
	currentShader = (currentShader+i)%#files
	shaderFileName="shader/"..files[currentShader+1]
	setShader(i)
end

function setShader(i)
	i = i or 1
	shaderData,iSystem = loadShader(shaderFileName)
	--shaderData,iSystem = loadShader("shader/balls.glsl")
	local OK
	OK, shader = pcall(love.graphics.newShader,shaderData)
	if not OK then
		--[[--
		print("-------SHADER---------")
		print(shaderFileName)
		print("--------ERROR---------")
		print(shader)
		print("------------------------------------")
		--]]--
		nextShader(i)
		setShader(i)
	end
	canvas = love.graphics.newCanvas(resolution[1],resolution[2])
	if iSystem.iResolution then
		shader:send("iResolution",iSystem.iResolution)
	end
	if iSystem.iChannel then
		for k,v in pairs(shaderChannel) do
			shader:send("iChannel"..k,v)
		end
	end
end

setShader(1)

function selectshadertoy(select)
i = i or 1
	--shaderData,iSystem = loadShader(shaderFileName)
	shaderData,iSystem = loadShader(select)
	local OK
	OK, shader = pcall(love.graphics.newShader,shaderData)
	if not OK then
		--[[--
		print("-------SHADER---------")
		print(shaderFileName)
		print("--------ERROR---------")
		print(shader)
		print("------------------------------------")
		--]]--
		nextShader(i)
		setShader(i)
	end
	canvas = love.graphics.newCanvas(resolution[1],resolution[2])
	if iSystem.iResolution then
		shader:send("iResolution",iSystem.iResolution)
	end
	if iSystem.iChannel then
		for k,v in pairs(shaderChannel) do
			shader:send("iChannel"..k,v)
		end
	end
end

--function love.keypressed(key)
--	if key == "right" then
		--nextShader(1)
	--elseif key == "left" then
--		nextShader(-1)
--	end
	--if key == 's' then 
--		selectshadertoy("shader/balls.glsl") 
	--end
--end

function love.resize(w,h)
	if iSystem.iResolution then
		resolution={love.graphics.getWidth(),love.graphics.getHeight(),1}
		iSystem.iResolution = {resolution[1],resolution[2],1}
		shader:send("iResolution",iSystem.iResolution)
		canvas = love.graphics.newCanvas(resolution[1],resolution[2])
	end
end

function love.update(dt)
--lovebpmupdate(dt)

	if gamestatus=="levelselection" then myshadowsupdate() 
elseif gamestatus=="credits" then creditsupdate(dt)
elseif gamestatus=="music" 	then musicupdate(dt)		--update music
--elseif gamestatus=="extras" then extrasupdate(dt)		--update extras
--elseif gamestatus=="leditor" then leditorupdate(dt)		--update extras
elseif gamestatus=="instructions" then instructionsupdate(dt)
elseif gamestatus=="intro" then introupdate(dt)
elseif gamestatus=="briefcasemessage" then
		briefcaseupdate(dt)
		timer = timer + dt	-- timer for the water warp shader
		subtitle2FDTOmessage()	
		
elseif gamestatus=="game" then timer = timer + dt	-- timer for the water warp shader
if nLevel==1 or nLevel==34 or nLevel==35 or nLevel==36 then whaleupdate(dt) end
if nLevel==3 or nLevel==32 or nLevel==101 then ffish1update(dt) fishsupdate(dt) end
if nLevel==7 or nLevel==21 or nLevel==30 or nLevel==31 or nLevel==34 or nLevel==35 or nLevel==36 or nLevel==102 then fishsupdate(dt) end
if nLevel==58 then squirrelupdate(dt) end

		--update subtitles
		if nLevel==1 then 			-- sync subtitles for level 1
				if chairtouched==false then
				
							if pipetouched==false and pipepushed==false and pipefalled==true then subtitles1() 
						elseif pipetouched==true and pipepushed==false then subtitles1Icantgetthrough() 
						elseif pipepushed==true and wowsaidonce==false then subtitles1wowyoumovedit()
						end
			
			elseif chairtouched==true then subtitles1damnit()
			end
			
						
			
		 
		 
	
	elseif nLevel==2 and briefcaseclosed==true then subtitlessync2() -- sync subtitles for level 2
	elseif nLevel==2 and briefcaseclosed==false then subtitle2thedisk() -- sync subtitles for level 2 after briefcase
	elseif nLevel==3 then subtitle3()
	elseif nLevel==4 then subtitle4()
	elseif nLevel==5 then subtitle5()
	elseif nLevel==6 then subtitle6()
	elseif nLevel==7 then subtitle7()
	elseif nLevel==8 then subtitle8()
	elseif nLevel==9 then subtitle9()
	elseif nLevel==10 then subtitle10()
	elseif nLevel==11 then subtitle11()
	elseif nLevel==12 then subtitle12()
	elseif nLevel==13 then subtitle13()
	elseif nLevel==14 then subtitle14()
	elseif nLevel==13 and skullpushed==true then subtitle13skull()
	elseif nLevel==15 then subtitle15()
	elseif nLevel==16 then subtitle16()
	elseif nLevel==17 then subtitle17()
	elseif nLevel==18 then subtitle18()
	elseif nLevel==19 then subtitle19()
	elseif nLevel==20 and skullpushed==false then subtitle20()
	elseif nLevel==20 and skullpushed==true then subtitle20skull()
	elseif nLevel==21 then subtitle21()
	elseif nLevel==22 then subtitle22()
	elseif nLevel==23 and zeusfalled==false then subtitle23()
	elseif nLevel==23 and zeusfalled==true then subtitle23zeus()
	elseif nLevel==24 then subtitle24()
	elseif nLevel==25 then subtitle25()
	elseif nLevel==26 then subtitle26()
	elseif nLevel==27 and dooropened==false then subtitle27()
	elseif nLevel==27 and dooropened==true then subtitle27door()
	elseif nLevel==28 and skullpushed==false then subtitle28()
	elseif nLevel==28 and skullpushed==true then subtitle28skull()
	elseif nLevel==29 then subtitle29()
	elseif nLevel==30 and crabtouched==true and not (crabfalled) then subtitle30crab()
	elseif nLevel==30 and crabfalled==true then subtitle30crabups()
	elseif nLevel==30 then subtitle30()
	elseif nLevel==31 then subtitle31()
	elseif nLevel==43 then subtitle43()
	elseif nLevel==45 then subtitle45()
	elseif nLevel==45 and skullpushed==false then subtitle45()
	elseif nLevel==45 and skullpushed==true then subtitle45skull()
	elseif nLevel==46 then subtitle46()
	elseif nLevel==47 then subtitle47()
	elseif nLevel==48 then subtitle48()
	elseif nLevel==49 then subtitle49()
	elseif nLevel==50 then subtitle50()
	elseif nLevel==51 then subtitle51()
	elseif nLevel==52 then subtitle52()
	elseif nLevel==53 then subtitle53()
	elseif nLevel==54 and enginepushed==false and engineononce==false and aproachengineonce==false then subtitle54()
	elseif nLevel==54 and enginepushed==true then subtitle54engineon()
	elseif nLevel==54 and enginepushed==false and engineononce==true then subtitle54engineoff()
	elseif nLevel==54 and enginepushed==false and aproachengineonce==true then subtitle54aproachengine()
	elseif nLevel==55 then subtitle55()
	elseif nLevel==56 and lightswitchon==true and lightswitchpushedafterfalling==true and aproachrobodog==false then subtitle56lightswitchon()
	elseif nLevel==56 and lightswitchon==false then subtitle56lightswitchoff()
	elseif nLevel==56 and aproachrobodog==true and lightswitchon==true then subtitle56aproachrobodog()
	elseif nLevel==57 then subtitle57()
	elseif nLevel==58 then subtitle58()
	elseif nLevel==59 and skullpushed==true then subtitle28skull()
	elseif nLevel==61 then subtitle61() 
	elseif nLevel==65 then subtitle65()
	end	
end
if shader2==true then
  if iSystem.iGlobalTime then
    iSystem.iGlobalTime=iSystem.iGlobalTime+dt
    shader:send("iGlobalTime", iSystem.iGlobalTime)
  end
  if iSystem.iMouse then
    iSystem.iMouse[1],iSystem.iMouse[2] = love.mouse.getPosition()
	iSystem.iMouse[1],iSystem.iMouse[2] = resolution[1]-iSystem.iMouse[1],resolution[2]-iSystem.iMouse[2]
    if love.mouse.isDown(1) then
        if iSystem.iMouse[3]<0 then
          iSystem.iMouse[3],iSystem.iMouse[4] = love.mouse.getPosition()
        end
        shader:send("iMouse", iSystem.iMouse)
    else
        iSystem.iMouse[3],iSystem.iMouse[4] = -1, -1
    end
  end
  --love.window.setTitle(shaderFileName.."; FPS: "..love.timer.getFPS())
  --love.window.setTitle("Fish Fillets remake")
    love.graphics.setShader(shader)
    love.graphics.draw(canvas)
end
end

--function love.draw()
 --love.graphics.draw(canvas,0,0,math.pi,1,1,resolution[1],resolution[2])
--end
